#!/usr/bin/puppybasic
include "/usr/lib/wxbasicscript/basefunctions.inc"

if fileexists("/usr/share/backgrounds/.puppybackgroundthumbnails") then
  shell("rm -rf /usr/share/backgrounds/.puppybackgroundthumbnails 2>/dev/null")
end if

progdir = "/usr/local/Puppybackground/"
picdir = ""
thumbdir = "/root/.pbthumbs"
shell("mkdir " & thumbdir & " 2>/dev/null")

arg = argvtostring()

if arg = "saved" then
  options=readfile("/etc/Puppybackgroundpicture")
  shell("Puppybackgroundsetter " & options)
  end
end if


  if left(arg , 10 ) = "-noguiDIR:" then
    if instr(arg , "/") then
      picdir = replace( arg , "-noguiDIR:" , "" )
      picdir = trim ( picdir )
      picdir = replace(picdir, "#pbdbgspace#", " ")
    end if
  end if

  if left(arg , 7 ) = "-nogui:" then
    if instr(arg , "/") then
      picdir = replace( arg , "-nogui:" , "" )
      picdir = trim ( picdir )
      picdir = replace(picdir, "#pbdbgspace#", " ")
    end if
  end if

if picdir = "" then
  testdir = readfile("./last.folder")
  if instr(testdir , "/") then
    testdir = replace(testdir, "#pbdbgspace#", " ")
    if fileexists(testdir) then
      picdir = testdir
      picdir = trim ( picdir )
    end if
  end if
end if

if picdir = "" then
  picdir = "/usr/share/backgrounds"
end if

shell("mkdir /root/Choices 2>/dev/null")

mytime = replace(date() , ":" , "") & replace(time() , ":" , "")
shell("ls \"" & picdir & "\" >/tmp/puppybackground.tmp")
files = readfiletolist("/tmp/puppybackground.tmp")
removefile("/tmp/puppybackground.tmp")

newthumbdir = thumbdir & "/"


for i= 1 to len(picdir)
  newthumbdir &= hex(asc(picdir[i]))
next

shell("mkdir \"" & newthumbdir & "\" 2>/dev/null")
shell("mkdir \"" & newthumbdir & "\" 2>/dev/null")
removefile(progdir & "resource/icons.rc")
shell("touch " & progdir & "resource/icons.rc")

if ! fileexists( newthumbdir & "/stats.txt") then
  shell("touch \"" & newthumbdir & "/stats.txt\"") 
end if

statistics = readfiletolist( newthumbdir & "/stats.txt")

shell("cd \"" & picdir & "\" &&stat * >/tmp/puppybackground.tmp")
newstatistics = readfiletolist("/tmp/puppybackground.tmp")
removefile("/tmp/puppybackground.tmp")

newstats = {}

i = 0
for each testline in newstatistics
  if instr( testline , "File:" ) then
    testline = cutleft(testline, "File: `" )
    testline = cutright(testline, "'" )
    newstats[testline] = newstatistics[ i + 6 ]
  end if
  i+=1
next

stats = {}
for each myline in statistics
  filename = cutright(myline , "###")

  statline = cutleft(myline , "###")
  stats[ filename ] = statline
  //-- delete dead thumbnails 
  thumb = replace( filename , " " , "#pbdbgspace#" ) & ".jpg"
  if ! fileexists( picdir & "/" & filename ) then
    removefile( newthumbdir & "/" & thumb )
  end if

next



Dim waitwindow = "'Desktop-background: " & mytime & "'"
Dim waitmessage =  " 'wait, creating thumbnails'"

ww = 0
if count(newstats) - count(stats) > 7 then
  xwin_exec( progdir & "resource/waitwindowpbdesk.sh " & waitwindow & waitmessage & " ")
  ww = 1
end if

for each theline in files
  thumbnail=replace(theline, " " , "#pbdbgspace#") & ".jpg"
  useit = 0
  if len(theline)>4 then
    suffix = lcase(right(theline , 4)) 
    select case suffix
      case ".jpg"
        useit = 1
      case ".png"
        useit = 1
      case ".bmp"
        useit = 1
      case ".xpm"
        useit = 1
      case ".gif"
        useit = 1
     end select

    if useit=1 then


      if ! fileexists( newthumbdir & "/" & thumbnail) then
        shell (  progdir & "resource/resamplefixedheight \"" & picdir & "/" & theline & "\" \"" & newthumbdir & "/" & thumbnail & "\" 60")

        stats[ theline ] =  newstats[ theline ]
'print "added: " & theline & " " & stats[ theline ] 
      else

        if stats[ theline ] != newstats[ theline ] then
  
         shell (  progdir & "resource/resamplefixedheight \"" & picdir & "/" & theline & "\" " & "\"" & newthumbdir & "/" & thumbnail & "\" 60")
         stats[ theline ] =  newstats[ theline ]
        end if
      end if

      appendstringtofile( progdir & "resource/icons.rc" , newthumbdir & "/" & thumbnail)
      thumbnailtitle = left(thumbnail , len(thumbnail)-4)
      appendstringtofile( progdir & "resource/icons.rc" ,  thumbnailtitle )
    end if
  end if

next

//-- execute the grafical interface 

if ww = 1 then
  shell ("sleep 1 &&killall waitwindowpbdesk.sh &")
end if

if left(arg ,6) != "-nogui" then
shell("cd " & progdir & "resource&&./list config.rc buttons1.rc buttons2.rc icons.rc&")
end if

  //-- remove dead entries from stats.txt
  removefile( newthumbdir & "/stats.txt")
  shell(" touch " & newthumbdir & "/stats.txt")

  for each filename , statline in stats

      if  fileexists ( picdir & "/" & filename ) then
        appendstringtofile( newthumbdir & "/stats.txt" , filename & "###" &  statline )
      end if
  next

'print stats



function unhex(theoldstring)

        theleft = left(theoldstring , 1) 

        Select Case theleft 
            Case "0" To "9" 
                thestring = Val(theleft) * 16 
            Case "A" 
                thestring = 10 * 16 
            Case "B" 
                thestring = 11 * 16 
            Case "C" 
                thestring = 12 * 16 
            Case "D" 
                thestring = 13 * 16 
            Case "E" 
                thestring = 14 * 16 
            Case "F" 
                thestring = 15 * 16 
        End Select 
        theright = right(theoldstring , 1 )
        Select Case theright 
            Case "0" To "9" 
                thestring += Val(theright) 
            Case "A" 
                thestring += 10 
            Case "B" 
                thestring += 11 
            Case "C" 
                thestring += 12 
            Case "D" 
                thestring += 13 
            Case "E" 
                thestring += 14 
            Case "F" 
                thestring += 15 
        End Select 
    thestring = chr(thestring)

  return thestring
end function


